<script setup lang="ts">
import {ref} from 'vue'

const name = ref('');
const mensajeErrorName = ref('');
const apellido = ref('');
const mensajeErrorApellido = ref('');
const edad = ref('');
const mensajeErrorEdad = ref('');
const genero = ref('');
const mensajeErrorGenero = ref('');
const otroGenero = ref('');
const error = ref(true);
const color =ref('#a467b9');

const Namevalidation = () => {
  const longitudname = name.value.length;
if (longitudname < 5 || longitudname > 18){
  error.value = true
  mensajeErrorName.value = 'Validar minimo 5 carateres maximo 18';
}else{
error.value = false;
mensajeErrorName.value = '';
}
};

const Apellidovalidation = () => {
if (apellido.value.toLowerCase() === name.value.toLowerCase()) {
  error.value = true
  mensajeErrorApellido.value = 'Validar que no sea igual al Nombre';
}else{
  error.value = false;
  mensajeErrorApellido.value = '';
}
}

const Edadvalidation = () => {
  const valorEdad = parseInt(edad.value, 10);

if (isNaN(valorEdad) || valorEdad <= 0 || valorEdad >= 60) {
  error.value = true;
  mensajeErrorEdad.value = 'La edad debe ser mayor a 0 y menor a 60.';
} else {
  error.value = false;
  mensajeErrorEdad.value = '';
}
};

const Generovalidation = () => {
  if (genero.value === 'Otro' && otroGenero.value.length === 0) {
    error.value = true;
    mensajeErrorGenero.value = 'Ingresa el género';
  } else {
    error.value = false;
    mensajeErrorGenero.value = '';
  }
};

</script>


<template>
  <main>
    
    <div class="form">
   <h1>Formulario</h1>

   <div class="container">
   <h2 class="titulo">Nombre</h2>
    <input @input="Namevalidation()" type="text" v-model="name" id="nombre" />
    <h1 :class="{'error': error}">{{ mensajeErrorName }}</h1>
    </div>
   
    <div class="container">
   <h3 class="titulo">Apellido</h3>
   <input @input="Apellidovalidation()" type = "text" v-model="apellido"/>
   <h1 :class="{'error': error}">{{ mensajeErrorApellido }}</h1>
  </div>

  <div class="container">
   <h4 class="titulo">Edad</h4>
   <select @input="Edadvalidation()" v-model="edad">
      <option :value="i" v-for="i in 60" :key="i">{{ i }}</option>
    </select>
    <h1 :class="{'error': error}">{{ mensajeErrorEdad }}</h1>
  </div>
   
  <div class="container">
   <h5 class="titulo">Genero</h5>
   <select @change="Generovalidation()" v-model="genero">
      <option value="Masculino">Masculino</option>
      <option value="Femenino">Femenino</option>
      <option value="Otro">Otro</option>
    </select>
    <input v-if="genero === 'Otro'" type="text" v-model="otroGenero" placeholder="Especificar genero" />
    <h1 :class="{'error': error}">{{ mensajeErrorGenero }}</h1>
    
  </div>
  </div>
  </main>
</template>

<style>

.form {
  border: 7px solid #000000;
  padding: 20px;
  max-width: 400px;
  margin: 0 auto;
  border-radius: 10px;
  color: #2b9fca;
  text-align: justify;
}

.container {
  margin-bottom: 20px;
}

.titulo {
  color: #2b9fca;
  font-size: 20px;
  
  box-sizing: border-box;
  width: 100%;
  text-align: justify;
}

.error{
  margin-top: 5px;
  text-align: justify;
  color: #a467b9;
  font-size: 18px;
  border-radius: 10px;
  padding: 5px;
}

</style>